Downgrade an APK?

VH
Last updated last month

Downgrade aren't allowed since Jelly Bean

Android has changed its behaviour when installing a new apk file. Until ICS (ice cream sandwich), it didn't mater if the new apk had a lower or higher android:versionCode in AndroidManifest.xml. After that, it's mandatory a higher versionCode. In fact, we can't guarantee "when" the new behavior was introduced, but we noticed it was sometime around Jelly Bean. When trying to install a lower version code through ADB, you will get the message: INSTALL_FAILED_VERSION_DOWNGRADE. In this case you can force with the undocumented -d flag: adb install -r -d my.apk. Pushlink can't force it because it just launches the APK and the control is passed to the OS. So, the installation process will fail with no specific error message. Keep in mind that Pushlink can't perform downgrades when the OS does not allow.